/*eslint-disable*/
import React from 'react';
import BubbleChart from '../common/charts/bubble-chart/index';
import {
  setSearchQuery,
} from '../../actions/app-actions';
import {constructGlobalSearchQuery} from '../../utils/search-utils';

class TopExploitableSeverityReport extends React.Component {
  constructor(props) {
    super(props);
    this.sectionClickHandler = this.sectionClickHandler.bind(this);
  }

  sectionClickHandler(point) {
    const {
      globalSearchQuery: existingQuery = [],
      dispatch,
    } = this.props;
    const pointSplit = point.split("/");

    let searchQuery = [];
    if (pointSplit[0]) {
      const severityParams = {
        cve_severity: pointSplit[0],
      };
      searchQuery = constructGlobalSearchQuery(existingQuery, severityParams);
    }

    if (pointSplit[1]) {
      const imageParams = {
        cve_container_image: pointSplit[1],
      };
      searchQuery = constructGlobalSearchQuery(searchQuery, imageParams);
    }

    const globalSearchQuery = {
      searchQuery,
    };
    dispatch(setSearchQuery(globalSearchQuery));
  }

  render() {
    const {
      data = [],
    } = this.props;
    const emptyData = data.length === 0;
    const showChart = !emptyData;
    return (
      <div className="relative">
        {(showChart &&
        <BubbleChart
          data={data}
          name="top-exploitable-severity-report"
          onSectionClick={this.sectionClickHandler}
          chartHeight={500}
          chartWidth={500}
        />
        )}
        <br />
      </div>
    );
  }
}

export default TopExploitableSeverityReport;
