package grype

import "github.com/anchore/grype/grype/presenter/models"

// Cvss is a struct that represents the CVSS object
func GetCvss(c []models.Cvss) (float64, float64, string) {
	var cvssScore float64
	var overallScore float64
	var attackVector string

	if len(c) == 0 {
		return 0, 0, ""
	}

	if len(c) == 1 {
		cvssScore = c[0].Metrics.BaseScore
		attackVector = c[0].Vector
		overallScore = *c[0].Metrics.ExploitabilityScore
	} else {
		for _, score := range c {
			if score.Version == "3.1" {
				cvssScore = score.Metrics.BaseScore
				attackVector = score.Vector
				overallScore = *score.Metrics.ExploitabilityScore
				break
			}
		}
	}

	// return cvss
	return cvssScore, overallScore, attackVector
}
